diff -ruNp ejudge-2.3.18/new_server_html_4.c ejudge/new_server_html_4.c
--- ejudge-2.3.18/new_server_html_4.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new_server_html_4.c	2011-07-11 09:02:04.156280514 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: new_server_html_4.c 6146 2011-03-26 10:47:14Z cher $ */
+/* $Id: new_server_html_4.c 6381 2011-06-25 18:52:12Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -56,6 +56,10 @@ parse_int(const char *str, int *p_val)
   int v;
   char *eptr = 0;
 
+  if (!str) return -1;
+  while (isspace(*str)) ++str;
+  if (!*str) return -1;
+
   errno = 0;
   v = strtol(str, &eptr, 10);
   if (errno || *eptr) return -1;
@@ -246,6 +250,24 @@ cmd_dump_problems(
 }
 
 static int
+cmd_dump_languages(
+        FILE *fout,
+        struct http_request_info *phr,
+        const struct contest_desc *cnts,
+        struct contest_extra *extra)
+{
+  const serve_state_t cs = extra->serve_state;
+  int i;
+  const struct section_language_data *lang;
+
+  for (i = 0; i <= cs->max_lang; i++) {
+    if (!(lang = cs->langs[i])) continue;
+    fprintf(fout, "%d;%s;%s;%s;%s\n", lang->id, lang->short_name, lang->long_name, lang->src_sfx, lang->exe_sfx);
+  }
+  return 0;
+}
+
+static int
 do_schedule(
         struct http_request_info *phr,
         serve_state_t cs,
@@ -393,15 +415,8 @@ cmd_operation(
 }
 
 static int
-cmd_operation_2(
-        FILE *fout,
-        struct http_request_info *phr,
-        const struct contest_desc *cnts,
-        struct contest_extra *extra)
+get_contest_type(FILE *fout, const struct section_global_data *global)
 {
-  int retval = 0;
-  const serve_state_t cs = extra->serve_state;
-  const struct section_global_data *global = cs->global;
   const unsigned char *s = 0;
   static const unsigned char * const contest_types[SCORE_TOTAL] =
   {
@@ -418,18 +433,110 @@ cmd_operation_2(
     [SCORE_MOSCOW] = 0,
   };
 
+  if (global->score_system < 0 || global->score_system >= SCORE_TOTAL) return -1;
+  if (global->is_virtual) s = virtual_contest_types[global->score_system];
+  else s = contest_types[global->score_system];
+  if (!s) return -1;
+  fprintf(fout, "%s", s);
+  return 0;
+}
+
+static int
+get_contest_status(
+        FILE *fout,
+        const serve_state_t cs,
+        time_t start_time,
+        time_t stop_time,
+        time_t duration)
+{
+  if (start_time > 0) {
+    if (stop_time > 0) {
+      if (duration == 0 || start_time + duration > cs->current_time) {
+        fprintf(fout, "paused");
+      } else {
+        fprintf(fout, "over");
+      }
+    } else {
+      fprintf(fout, "running");
+    }
+  } else {
+    fprintf(fout, "not started");
+  }
+  return 0;
+}
+
+static int
+get_positive_time(FILE *fout, time_t t)
+{
+  if (t > 0) {
+    fprintf(fout, "%s", xml_unparse_date(t));
+  } else {
+    fprintf(fout, "%d", 0);
+  }
+  return 0;
+}
+
+static int
+get_contest_duration(FILE *fout, int duration)
+{
+  fprintf(fout, "%d", duration);
+  return 0;
+}
+
+static int
+cmd_operation_2(
+        FILE *fout,
+        struct http_request_info *phr,
+        const struct contest_desc *cnts,
+        struct contest_extra *extra)
+{
+  int retval = 0;
+  const serve_state_t cs = extra->serve_state;
+  const struct section_global_data *global = cs->global;
+  time_t start_time = 0, duration = 0, stop_time = 0, sched = 0;
+
+  run_get_times(cs->runlog_state, &start_time, &sched, &duration, &stop_time, 0);	
   switch (phr->action) {
   case NEW_SRV_ACTION_GET_CONTEST_NAME:
     fprintf(fout, "%s", cnts->name);
     break;
   case NEW_SRV_ACTION_GET_CONTEST_TYPE:
-    if (global->score_system < 0
-        || global->score_system >= SCORE_TOTAL)
-      FAIL(NEW_SRV_ERR_INV_CONTEST_ID);
-    if (global->is_virtual) s = virtual_contest_types[global->score_system];
-    else s = contest_types[global->score_system];
-    if (!s) FAIL(NEW_SRV_ERR_INV_CONTEST_ID);
-    fprintf(fout, "%s", s);
+    if (get_contest_type(fout, global) < 0) FAIL(NEW_SRV_ERR_INV_CONTEST_ID);
+    break;
+  case NEW_SRV_ACTION_GET_CONTEST_STATUS:
+    get_contest_status(fout, cs, start_time, stop_time, duration);
+    break;
+  case NEW_SRV_ACTION_GET_CONTEST_SCHED:
+    get_positive_time(fout, sched);
+    break;
+  case NEW_SRV_ACTION_GET_CONTEST_DURATION:
+    get_contest_duration(fout, duration);
+    break;
+  case NEW_SRV_ACTION_GET_CONTEST_DESCRIPTION:
+    /*
+    {
+    'name' : '<name>',
+    'type' : '<type>',
+    'status' : '<status>',
+    'start' : '<start time>',
+    'duration' : '<duration in seconds>',
+    'stop' : '<stop time>',
+    'sched' : '<schedule time>'
+    }
+    */
+    fprintf(fout, "{ 'name' : '%s', 'type' : '", cnts->name);
+    if (get_contest_type(fout, global) < 0) FAIL(NEW_SRV_ERR_INV_CONTEST_ID);
+    fprintf(fout, "', 'status' : '");
+    get_contest_status(fout, cs, start_time, stop_time, duration);
+    fprintf(fout, "', 'start' : '");
+    get_positive_time(fout, start_time);
+    fprintf(fout, "', 'duration' : '");
+    get_contest_duration(fout, duration);
+    fprintf(fout, "', 'stop' : '");
+    get_positive_time(fout, stop_time);
+    fprintf(fout, "', 'sched' : '");
+    get_positive_time(fout, sched);
+    fprintf(fout, "' }");
     break;
   default:
     abort();
@@ -685,12 +792,17 @@ cmd_submit_run(
 
   if (ns_cgi_param(phr, "prob", &s) <= 0)
     FAIL(NEW_SRV_ERR_INV_PROB_ID);
-  for (i = 1; i <= cs->max_prob; i++)
-    if (cs->probs[i] && !strcmp(s, cs->probs[i]->short_name))
-      break;
-  if (i > cs->max_prob)
-    FAIL(NEW_SRV_ERR_INV_PROB_ID);
-  prob = cs->probs[i];
+  if (s && *s == '#') {
+    if (parse_int(s + 1, &i) < 0 || i <= 0 || i > cs->max_prob || !(prob = cs->probs[i]))
+      FAIL(NEW_SRV_ERR_INV_PROB_ID);
+  } else {
+    for (i = 1; i <= cs->max_prob; i++)
+      if (cs->probs[i] && !strcmp(s, cs->probs[i]->short_name))
+        break;
+    if (i > cs->max_prob)
+      FAIL(NEW_SRV_ERR_INV_PROB_ID);
+    prob = cs->probs[i];
+  }
 
   /* check variant */
   switch (phr->role) {
@@ -1690,6 +1802,7 @@ static cmd_handler_t cmd_actions_table[N
   [NEW_SRV_ACTION_VIEW_RUNS_DUMP] = cmd_dump_runs,
   [NEW_SRV_ACTION_LOGOUT] = cmd_logout,
   [NEW_SRV_ACTION_DUMP_PROBLEMS] = cmd_dump_problems,
+  [NEW_SRV_ACTION_DUMP_LANGUAGES] = cmd_dump_languages,
   [NEW_SRV_ACTION_SOFT_UPDATE_STANDINGS] = cmd_operation,
   [NEW_SRV_ACTION_TEST_SUSPEND] = cmd_operation,
   [NEW_SRV_ACTION_TEST_RESUME] = cmd_operation,
@@ -1700,6 +1813,10 @@ static cmd_handler_t cmd_actions_table[N
   [NEW_SRV_ACTION_DUMP_CLAR] = cmd_clar_operation,
   [NEW_SRV_ACTION_GET_CONTEST_NAME] = cmd_operation_2,
   [NEW_SRV_ACTION_GET_CONTEST_TYPE] = cmd_operation_2,
+  [NEW_SRV_ACTION_GET_CONTEST_STATUS] = cmd_operation_2,
+  [NEW_SRV_ACTION_GET_CONTEST_SCHED] = cmd_operation_2,
+  [NEW_SRV_ACTION_GET_CONTEST_DURATION] = cmd_operation_2,
+  [NEW_SRV_ACTION_GET_CONTEST_DESCRIPTION] = cmd_operation_2,
   [NEW_SRV_ACTION_SUBMIT_RUN] = cmd_submit_run,
   [NEW_SRV_ACTION_UPLOAD_RUNLOG_XML_2] = cmd_import_xml_runs,
   [NEW_SRV_ACTION_DUMP_MASTER_RUNS] = cmd_dump_master_runs,
diff -ruNp ejudge-2.3.18/new_server_html_5.c ejudge/new_server_html_5.c
--- ejudge-2.3.18/new_server_html_5.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new_server_html_5.c	2011-07-11 09:02:04.218279374 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: new_server_html_5.c 6146 2011-03-26 10:47:14Z cher $ */
+/* $Id: new_server_html_5.c 6353 2011-05-28 07:35:10Z cher $ */
 
 /* Copyright (C) 2007-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -106,7 +106,7 @@ anon_select_contest_page(FILE *fout, str
   const int *cntslist = 0;
   int cntsnum = 0;
   const unsigned char *cl;
-  const struct contest_desc *cnts;
+  const struct contest_desc *cnts = NULL;
   time_t curtime = time(0);
   int row = 0, i, orig_locale_id, j;
   const unsigned char *s;
@@ -121,7 +121,7 @@ anon_select_contest_page(FILE *fout, str
 
   // even don't know about the contest specific settings
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, ns_fancy_header, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, ns_fancy_header, 0, 0, 0, 0, phr->locale_id, NULL,
             _("Contest selection"));
 
   html_start_form(fout, 1, phr->self_url, "");
@@ -140,7 +140,7 @@ anon_select_contest_page(FILE *fout, str
 
   fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td></tr></table></div>\n");
 
-  fprintf(fout, "%s", ns_fancy_separator);
+  ns_separator(fout, ns_fancy_separator, cnts);
 
   fprintf(fout, "<h2>%s</h2>\n", _("Select one of available contests"));
 
@@ -231,7 +231,7 @@ login_page(
     s = _("Log in to edit registration data");
     break;
   }
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s]", s, extra->contest_arm);
 
   html_start_form(fout, 1, phr->self_url, "");
@@ -282,7 +282,7 @@ login_page(
     fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td>");
   fprintf(fout, "</tr></table></div>\n");
 
-  fprintf(fout, "%s", extra->separator_txt);
+  ns_separator(fout, extra->separator_txt, cnts);
 
   if (phr->action == NEW_SRV_ACTION_REG_ACCOUNT_CREATED_PAGE) {
     fprintf(fout, "<%s>%s</%s>\n", head_style,
@@ -394,7 +394,7 @@ create_autoassigned_account_page(
   if (!email) email = "";
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s]", _("Create user account"),
             extra->contest_arm);
 
@@ -430,7 +430,7 @@ create_autoassigned_account_page(
     fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td>");
   fprintf(fout, "</tr></table></div>\n");
 
-  fprintf(fout, "%s", extra->separator_txt);
+  ns_separator(fout, extra->separator_txt, cnts);
 
   if (reg_error || reg_ul_error) {
     if (reg_error < 0) reg_error = -reg_error;
@@ -541,7 +541,7 @@ create_account_page(
   if (!email) email = "";
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s]", _("Create user account"),
             extra->contest_arm);
 
@@ -577,7 +577,7 @@ create_account_page(
     fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td>");
   fprintf(fout, "</tr></table></div>\n");
 
-  fprintf(fout, "%s", extra->separator_txt);
+  ns_separator(fout, extra->separator_txt, cnts);
 
   if (reg_error || reg_ul_error) {
     if (reg_error < 0) reg_error = -reg_error;
@@ -684,6 +684,8 @@ create_account(
   if (!r || !email) FAIL2(NEW_SRV_ERR_EMAIL_UNSPECIFIED);
   if (check_str(email, email_accept_chars) < 0)
     FAIL2(NEW_SRV_ERR_EMAIL_INV_CHARS);
+  if (!is_valid_email_address(email))
+    FAIL2(NEW_SRV_ERR_EMAIL_INV_CHARS);
 
   // if neither login nor email are specified, just change the locale
   if (!*login && !*email) {
@@ -1671,7 +1673,7 @@ main_page(
   n = phr->name;
   if (!n || !*n) n = phr->login;
 
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %s]", title, ARMOR(n), extra->contest_arm);
 
   shown_items = 0;
@@ -1719,7 +1721,7 @@ main_page(
     fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td>");
   fprintf(fout, "</tr></table></div>\n");
   if (extra->separator_txt && *extra->separator_txt) {
-    fprintf(fout, "%s", extra->separator_txt);
+    ns_separator(fout, extra->separator_txt, cnts);
   }
 
   // status row
@@ -2296,7 +2298,7 @@ edit_page(
   n = phr->name;
   if (!n || !*n) n = phr->login;
 
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %s]", s, ARMOR(n), extra->contest_arm);
 
   fprintf(fout, "<div class=\"user_actions\"><table class=\"menu\"><tr>");
@@ -2309,7 +2311,7 @@ edit_page(
   fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td>");
   fprintf(fout, "</tr></table></div>\n");
   if (extra->separator_txt && *extra->separator_txt) {
-    fprintf(fout, "%s", extra->separator_txt);
+    ns_separator(fout, extra->separator_txt, cnts);
   }
 
   // status row
@@ -2395,7 +2397,7 @@ action_error_page(
   s = _("Operation errors");
   n = phr->name;
   if (!n || !*n) n = phr->login;
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %s]", s, ARMOR(n), extra->contest_arm);
 
   fprintf(fout, "<div class=\"user_actions\"><table class=\"menu\"><tr>");
@@ -2408,7 +2410,7 @@ action_error_page(
   fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td>");
   fprintf(fout, "</tr></table></div>\n");
   if (extra->separator_txt && *extra->separator_txt) {
-    fprintf(fout, "%s", extra->separator_txt);
+    ns_separator(fout, extra->separator_txt, cnts);
   }
 
   fprintf(fout, "<br><font color=\"red\"><pre>%s</pre></font><br>\n",
